
iDQ
==========================================================================

[![pipeline status](https://git.ligo.org/reed.essick/iDQ/badges/master/pipeline.svg)](https://git.ligo.org/reed.essick/iDQ/commits/master)
[![conda-forge](https://img.shields.io/conda/vn/conda-forge/idq.svg)](https://anaconda.org/conda-forge/idq)

|              |        |
| ------------ | ------ |
| **Version:** | 0.3.0  |
| **Docs:**     | https://docs.ligo.org/reed.essick/iDQ  |
| **Source:**  | http://software.ligo.org/lscsoft/source/iDQ-0.3.0.tar.gz  |

## Installation/Quickguide

  * [Installation](https://docs.ligo.org/reed.essick/iDQ/installation.html)
  * [Running Batch Jobs](https://docs.ligo.org/reed.essick/iDQ/tutorials/running_batch_pipeline.html)
  * [Running Streaming Jobs](https://docs.ligo.org/reed.essick/iDQ/tutorials/running_stream_pipeline.html)

## Design Document

Currently a work-in-progress, but is available here

  - https://www.overleaf.com/10661300shbwgjyyqgvz#/39942261/

We will attempt to keep an up-to-date copy within this repository's documentation and on the DCC.

## Dependencies

Besides the standard built-in Python libraries (based on Python2.7)

### Functionality/Operation

LDG-standard python packages:
  - numpy
  - h5py
    - used to read/write data to disk

Non-standard python packages:
  - scikit-learn ([v0.18.2](https://pypi.python.org/pypi/scikit-learn/0.18.2))
    - used within some MLA classifiers
  - cython ([v0.25.2](https://pypi.python.org/pypi/Cython/0.25.2))
    - dependency for scikit-learn
  - confluent-kafka-python ([v0.11.5](https://github.com/confluentinc/confluent-kafka-python/releases/tag/v0.11.5))
    - Python bindings for Kafka

Non-python packages:
  - Kafka ([v1.1.1, Scala 2.11](http://kafka.apache.org/))
    - dependency for streaming processes
  - librdkafka([v0.11.5](https://github.com/edenhill/librdkafka/releases/tag/v0.11.5))
    - Kafka C/C++ client library

### Documentation 

  - sphinx

### Testing

  - pytest ([v.2.7.0+](https://docs.pytest.org/))

-------------------------------------------------

## For Developers

### Python Style Guide

  - Objects should return themselves when there is no other obvious data product. For example, 
    - SupervisedClassifier.train should build an internal model and then return a copy of itself whereas 
    - SupervisedClassifier.timeseries should return a list of arrays of ranks, one element for each segment requested (contained within the classifier_data object passed)
  - spaces instead of tabs, with 4-spaces per indent block
  - if there are more than 3 input arguments for a function call, the call should be broken across multiple lines with appropriate indentation
  - all functions and method names should follow the snake case convention, e.g. foo_bar(), where underscores are used to separate names

### Data formats

As much as possible, data written to disk should follow the Common Data Format recommendations
    - https://wiki.ligo.org/DetChar/CommonDataFormat
However, within memory we will not require any particular data format. For example, we will allow ourselves to instantiate and pass around numpy structured arrays instead of hd5f dataset objects even though we will always represent the numpy arrays as datasets when writing them to disk.
